%% Ucitavanje slika
im1 = im2double(imread('bl_band1.tif'));
im2 = im2double(imread('bl_band2.tif'));
im3 = im2double(imread('bl_band3.tif'));
im4 = im2double(imread('bl_band4.tif'));
im5 = im2double(imread('bl_band5.tif'));
im7 = im2double(imread('bl_band7.tif'));
im = cat(3, im1, im2, im3, im4, im5, im7);
im_rgb = cat(3, im3, im2, im1);
figure, imshow(im_rgb);

%% Maske trening regiona
% zemljiste prekriveno vegetacijom
% B1 = roipoly;
B1 = imread('maska1.tif');
% urbano izgradjeno zemljiste
% B2 = roipoly;
B2 = imread('maska2.tif');
% obradivo zemljiste
% B3 = roipoly;
B3 = imread('maska3.tif');

%% Izdvojiti trening vektore
[X1, R1] = imstack2vectors(im, B1);
[X2, R2] = imstack2vectors(im, B2);
[X3, R3] = imstack2vectors(im, B3);

%% Izracunavanje statistika trening vektora
% Srednje vrijednosti
m1 = mean(X1);
m2 = mean(X2);
m3 = mean(X3);
MA = [m1', m2', m3'];

% Kovarijansne matrice
Cx1 = cov(X1);
Cx2 = cov(X2);
Cx3 = cov(X3);
CA = cat(3, Cx1, Cx2, Cx3);

%% Klasifikacija
[M, N, n] = size(im);
Xtest = reshape(im, M*N, n);

map = classify(Xtest, CA, MA);
map = reshape(map, M, N);
figure, imshow(label2rgb(map));
